#define F_CPU 8000000UL
# include <avr/io.h>
#include <util/delay.h>

//**************************************************************
// Pseudo Random Lauflicht, 8 Kanal
// By B. Redemann, March 2007
//
//**************************************************************
 
int main(void)
{

//Variablen zur Berechnung des XOR Outputs
int StartWert=0x01;
int Wert, Delaytime;

unsigned char XORErg = 0;
unsigned char XORWert1, XORWert2;
Wert = StartWert;
//*****************************************

//Tiny 26, Port PB0 - Pa7
DDRB = 0xFF;

//Port A auf Eingnge (Poti)
DDRA = 0x00;

//A/D Wandler initialisieren
//7 6 5 4 3 2 1 0
//1 0 1 0 0 1 1 0 
//REF int. 2.54V
//left adjusted
//ADC 6
ADMUX = 0xA6;

ADCSR = 0xE7;

while (1)
  {
      PORTB = Wert;
            
      XORWert1 = (0x40 & Wert) >>6;
      XORWert2 = (0x20 & Wert) >>5;
      XORErg = XORWert1 ^ XORWert2;
      
      if (XORErg == 0)
      {
          Wert = Wert << 1;
      }
      if (XORErg == 1)
      {
          Wert = (Wert << 1) + XORErg;
      }  
      
      //Etwas warten, abhngig vom Poti  
      Delaytime = ADCH / 12;
      _delay_ms(Delaytime);
	  //Festes delay
	  //_delay_ms(1000);
  } 
return 0;
}
